#include "defs.h"
#include  <X11/Xlib.h>
#include  <X11/Xutil.h>
#include <X11/cursorfont.h>
#include  <stdio.h>
#include <math.h>

double xmin, xmax, 
       ymin, ymax;

Display		*disp;
int		screenno; 
Colormap        colormap;
unsigned long int black, white;
unsigned int     width=MAXX+1, height=MAXY+1;
XSetWindowAttributes WA;
unsigned long   wmask;
XSizeHints      SH;
int             bordwidth = 2, depth;
Window          wind;
int             xpos = 1, ypos = 1;
GC              gcontext;
XFontStruct     *fontstruct;
XGCValues       gvalues;
unsigned long int gmask;


main(argc, argv)
int argc;
char *argv[];
{
   void graph_points(), graph_line();
   double x[K+1][MAXM+1], delta[K+1][MAXM+1], w[K][MAXM+1][MAXM+1],
          d, label[N+1], pattern[DIM+1][N+1], c, sum, f(), x_vert[5], y_vert[5];
   int i, j, k, iter, niter, n, u, p, statsdispfreq, linedispfreq, count,count2;
   static int M[] = {2, 3, 1};
   FILE *pin, *pinit;

   niter = atoi(argv[1]);
   c = atof(argv[2]);
   statsdispfreq = atoi(argv[3]);
   linedispfreq = atoi(argv[4]);

   disp = XOpenDisplay( NULL );
   if ( disp == NULL )
   {
      fprintf( stderr, "Error opening display.\n"); 
      exit( 1 );
   }
   
   screenno   = DefaultScreen(disp);
   depth      = DefaultDepth(disp,screenno);
   black      = BlackPixel(disp,screenno);
   white      = WhitePixel(disp,screenno);
   colormap   = DefaultColormap(disp,screenno);

   WA.border_pixel = black;
   WA.background_pixel = white;
   WA.override_redirect = True;
   wmask = CWBackPixel | CWBorderPixel | CWOverrideRedirect;

   wind = XCreateWindow (disp, RootWindow(disp, screenno), xpos, ypos, 
	      width, height, bordwidth, depth, InputOutput, CopyFromParent, 
	      wmask, &WA);
   
   SH.flags = PPosition | PSize;
   SH.x = xpos;
   SH.y = ypos;
   SH.width = width;
   SH.height = height; 
   
   XSetNormalHints(disp, wind, &SH);

   gmask = 0L;
   gcontext = XCreateGC(disp, wind, gmask, &gvalues);
   XSetForeground(disp, gcontext, black);
   XSetBackground(disp, gcontext, white);

   XMapWindow(disp, wind);

   if((fontstruct = XLoadQueryFont(disp, "variable")) == 0)
      exit(2);
     XSetFont(disp, gcontext, fontstruct->fid); 
       
       /* Get max and min for scaling */
    pin = fopen("training.dat", "r");
    fscanf(pin, "%lf%lf", &xmin, &xmax);
    fscanf(pin, "%lf%lf", &ymin, &ymax);

      /* Get patterns and labels from file */
   for (n=1; n<=N && fscanf(pin, "%lf%lf%lf", 
      &pattern[1][n], &pattern[2][n], &label[n]) != EOF; n++)	;
   n--;

printf("n = %d\n", n);

      /* Initialize constant nodes */
   for (k=0; k<=K-1; k++) x[k][0] = 1.0; 

      /* Initialize weights */
   pinit = fopen("raninit.dat", "r");
   for (k=0; k<=K-1; k++)
      for (i=1; i<=M[k+1]; i++)
         for (j=0; j<=M[k]; j++)
 fscanf(pinit, "%lf", &w[k][i][j]);

      /* Graph points */
   graph_points(n, pattern[1], pattern[2], label);

   printf("Constant = %f\n", c);
      /* Perform iterations */
   for (iter=1; iter<=niter; iter++)
   {
      if (iter % statsdispfreq == 0)  
      {
           printf("Iteration = %3d\n", iter);
	   fprintf(stderr, "Iter = %3d\n", iter);
      }

      count = 0;
      count2 = 0;
      for (p=1; p<=n; p++)
      {
	    /* Get next pattern and label */
	 for (j=1; j<=M[0]; j++)
	 {
	    x[0][j] = pattern[j][p];
	    d = label[p];
	 }
/***************
for (k=0; k<=K-1; k++)
   for (i=1; i<=M[k+1]; i++)
   {
      printf("x[%d][%d] == %lf\n", k, i,  x[k][i]);
      for (j=0; j<=M[k]; j++)
         printf("w[%d][%d][%d] == %lf\n", k, i, j, w[k][i][j]);
   }
***************/
	    /* Feedforward step */
         for (k=0; k<K; k++)
            for (i=1; i<=M[k+1]; i++)
	    {
	       sum = 0.0;
               for (j=0; j<=M[k]; j++) {
		   sum += w[k][i][j]*x[k][j];
/*  printf("sum = %lf\n", sum); */
               }
 	       x[k+1][i] = f(sum);
	    }

 	    /* Compute top level delta */
         for (j=1; j<=M[K]; j++) { 
            delta[K][j] = x[K][j]*(1-x[K][j])*(d-x[K][j]);
/* printf("delta[%d][%d]=%lf \n", K, j, delta[K][j]); */
             }

	    /* Compute lower level deltas recursively */
	 for (k=K-1; k>=0; k--)
            for (j=0; j<=M[k]; j++)
            {
	       sum = 0.0;
	       for (u=1; u<=M[k+1]; u++) 
               {
			sum += delta[k+1][u]*w[k][u][j];
/*  printf("delta[%d][%d] == %lf\n", k+1, u, delta[k+1][u]);
    printf("w[%d][%d][%d] == %lf\n", k, u, j, w[k][u][j]);
    printf("sum = %lf\n", sum);                              */
               }
               delta[k][j] = x[k][j]*(1-x[k][j])*sum;
/*  printf("delta[%d][%d] == %lf\n", k, j,  delta[k][j]);   */
	    }

	    /* Adjust the weights */
	 for (k=0; k<K; k++)
	    for (i=1; i<=M[k+1]; i++)
	       for (j=0; j<=M[k]; j++)  
               {
/*  printf("k=%d  i=%d  j=%d\n", k, i, j);  */
		  w[k][i][j] += c*delta[k+1][i]*x[k][j];
               }

              if (iter % statsdispfreq == 0) { 
	         printf("%8.4f %5.1f ", x[K][1], d);
                if ((count++) % 5 == 0)
		    printf("\n"); 
              }

          }
	    /* Graph the lines in the decision boundaries */
          if((iter % linedispfreq) == 0) {
	     
	     for (i=1; i<=M[1]; i++)
                  graph_line(w[0][i], x_vert, y_vert); 
	     XFlush(disp);
          }

	  if((iter % statsdispfreq ) == 0) {
	     XClearWindow(disp, wind);
             graph_points(n, pattern[1], pattern[2], label);
	     printf("\n");
	     for (i=1; i<=M[1]; i++) {
                graph_line(w[0][i], x_vert, y_vert);  
	        printf("Line %d (%f,%f) (%f,%f)\n",  
		  i, x_vert[0], y_vert[0], x_vert[1], y_vert[1]);
             }
	     XFlush(disp);
          }
      
         if (iter % statsdispfreq == 0) {
            printf(" \n");
	    for(k=0; k<=K-1; k++)
            for(i=1; i<=M[k+1]; i++) 
               for(j=0; j<=M[k]; j++) {
                  printf("w[k][%d][%d] = %11.4lf ", i, j, w[k][i][j]);
               if ((count2++) % 3 == 0)
		  printf("\n");
            }
            printf("\n");
         }
   }
}
  	  
void graph_points(i, x, y, class)
int i;
double x[], y[], class[];
{ 
     int j, xnew, ynew;
     char text[2];

  for(j = 1; j <= i; ++j){
      xnew = SCALE_X(x[j]);
      ynew = SCALE_Y(y[j]);
      sprintf(text, "%1.0f", class[j]);
      XDrawImageString(disp, wind, gcontext, xnew, 
			MAXY-ynew, text, strlen(text));
      XFlush(disp);
   }
}



void graph_line(w, x_vert, y_vert)
double w[], x_vert[], y_vert[];
{
   int i, k = 0, a,b,c,d, inter;

       inter = intersect(w[1], w[2], w[0], x_vert, y_vert);
       if (inter >= 2){
	 a = SCALE_X(x_vert[0]);
	 b = SCALE_Y(y_vert[0]);
	 c = SCALE_X(x_vert[1]);
	 d = SCALE_Y(y_vert[1]);
         XDrawLine(disp, wind, gcontext, a, MAXY-b, c, MAXY-d);
       }    
}



int intersect(a, b, c, x_vert, y_vert)
double a, b, c;
double x_vert[], y_vert[];
{

   int i;
   double D, D_x, D_y;
   double solve();

   /* Solve x = 0 and x = 10 with current input line */

   i=0;

   D = solve(1.00, b, a, 0.00);
   if (fabs(D) > TOL){
     D_y = solve(1.00, -c, a, xmin);
     if(RANGE_Y){
      y_vert[i] = D_y/D;
      x_vert[i] = xmin;
      ++i;
     }


      D_y =  solve(1.00, -c, a, xmax);
      if(RANGE_Y){
      x_vert[i] = xmax;
      y_vert[i] = D_y/D;
      ++i;
     }

    }


    /* Solve y = 0 and y = 6 with current input line */

    D = solve(0.00, b, a, 1.00);
    if (fabs(D) >TOL) {
      D_x = solve(ymin, b, -c, 1.00);
      if(RANGE_X){
        x_vert[i] = D_x/D;
        y_vert[i] = ymin;
        ++i;
       }


      D_x = solve(ymax, b, -c, 1.00);
      if(RANGE_X){
        x_vert[i] = D_x/D;
        y_vert[i] = ymax; 
        ++i;
      }
    }
      if ((i>2) && (fabs(x_vert[1]-x_vert[0])<TOL) 
	   && (fabs(y_vert[1]-y_vert[0])<TOL)) {
              x_vert[1] = x_vert[2];
              y_vert[1] = y_vert[2];  
       }                            
    return i;
} 


double solve(w, x, y, z)
double w, x, y, z;
{
    return w * x - y * z;
}




double f(sum)
double sum;
{

     return (1.0/(1.0 + exp(-sum)));
}
