OPTIONS LINESIZE=64 pagesize=40 NODATE NONUMBER;
FILENAME RAWDATA 'coins.dat';

   /* Create a new SAS data set called COINS */
DATA COINS;
   INFILE RAWDATA;
   INPUT DENOM $ X Y AREA AVEGRAY;
   DROP X Y;
   LABEL DENOM   = 'Denomination'
         AREA    = 'Area of coin in pixels'
         AVEGRAY = 'Average gray level of coin';

   /* Print the data set COINS */
PROC PRINT;
   VAR DENOM AREA AVEGRAY;

   /* Plot the data set COINS */
PROC PLOT;
   PLOT AVEGRAY*AREA=DENOM;

   /* Sort COINS by DENOM */
PROC SORT;
   BY DENOM;

   /* Print COINS data set by DENOM */
PROC PRINT;
   BY DENOM;
   VAR AREA AVEGRAY;

   /* Perform Bayesian classification using a separate */
   /* covariance matrix for each class and the         */
   /* resubsitution method for error checking.         */

   /* Use only feature AVEGRAY */
PROC DISCRIM DATA=COINS LIST POOL=NO;
   CLASS DENOM;
   VAR AVEGRAY;
   /* Use only feature AREA */
PROC DISCRIM DATA=COINS LIST POOL=NO;
   CLASS DENOM;
   VAR AREA;
  /* Use both features */
PROC DISCRIM DATA=COINS LIST POOL=NO;
   CLASS DENOM;
   VAR AREA AVEGRAY;
