OPTIONS LINESIZE=64 PAGESIZE=40 NODATE NONUMBER;
FILENAME RAWDATA 'coins2.dat';

   /* Create a new SAS data set called COINS */
   /* Randomly assign samples to training    */
   /* and test sets                          */
DATA TRAIN TEST;
   INFILE RAWDATA;
   INPUT DENOM $ X Y AREA AVEGRAY SET;
   IF SET=0 
      THEN OUTPUT TRAIN;
   ELSE IF SET=1 
      THEN OUTPUT TEST;
   DROP X Y SET;
   LABEL DENOM   = 'Denomination'
         AREA    = 'Area of coin in pixels'
         AVEGRAY = 'Average gray level of coin';

   /* Print the training data set */
PROC PRINT DATA=TRAIN;
   VAR DENOM AREA AVEGRAY;

   /* Print the test data set */
PROC PRINT DATA=TEST;
   VAR DENOM AREA AVEGRAY;

   /* Use Bayesian classification based on training set */
   /* TRAIN and test is using test set TEST             */
PROC DISCRIM DATA=TRAIN TESTDATA=TEST LIST TESTLIST POOL=NO;
   CLASS DENOM;
   VAR AREA AVEGRAY;
