OPTIONS LINESIZE=64 PAGESIZE=40 NODATE NONUMBER;
FILENAME RAWDATA 'coins.dat';

   /* Create a new SAS data set called COINS */
DATA COINS;
   INFILE RAWDATA;
   INPUT DENOM $ X Y AREA AVEGRAY;
   DROP X Y;
   LABEL DENOM   = 'Denomination'
         AREA    = 'Area of coin in pixels'
         AVEGRAY = 'Average gray level of coin';

/*
PROC PRINCOMP OUT=PRINOUT NOPRINT;
   VAR SEPLEN SEPALWID PETLEN PETALWID;
/*

   /* Perform cluster analysis on standardized */
   /* variables using average linkage          */
PROC CLUSTER OUTTREE=OUT1 STANDARD METHOD=AVERAGE;
   VAR AREA AVEGRAY;

   /* Draw cluster tree */
PROC TREE NCLUSTERS=3 OUT=OUT2;
   COPY AREA AVEGRAY;

   /* Plot data set using cluster number as */
   /* plotting symbol                       */
PROC PLOT;
   PLOT AVEGRAY*AREA=CLUSTER;

