OPTIONS LINESIZE=64 PAGESIZE=40 NODATE NONUMBER;
FILENAME RAWDATA 'coins2.dat';

   /* Create a new SAS data set called COINS */
DATA TRAIN TEST;
   INFILE RAWDATA;
   INPUT DENOM $ X Y AREA AVEGRAY SET;
   IF SET=0 
      THEN OUTPUT TRAIN;
   ELSE IF SET=1 
      THEN OUTPUT TEST;
   DROP X Y;
   LABEL DENOM   = 'Denomination'
         AREA    = 'Area of coin in pixels'
         AVEGRAY = 'Average gray level of coin'
         SET     = '0=training, 1=test';

PROC NEIGHBOR K=1 DATA=TRAIN TESTDATA=TEST IDENTITY LIST TESTLIST;
   CLASS DENOM;
   VAR AREA AVEGRAY;

PROC NEIGHBOR K=3 DATA=TRAIN TESTDATA=TEST IDENTITY LIST TESTLIST;
   CLASS DENOM;
   VAR AREA AVEGRAY;
