#include <stdio.h>
#include <stdlib.h>

#if vax11c
#define EXIT_SUCCESS 1
#define EXIT_FAILURE 0
#endif

#define Width  30
#define Height 30

/* There is an extra row and column.
   Row pix[ 0 ][ ] and column pix[ ][ 0 ] are all
   zeros. The object-labeling algorithm uses
   this dummy row and column. */
short pix[ Height + 1 ][ Width + 1 ];
int width, height;  /* actual width & height */
int cc = 2; /* number of connected component */

void read_pix( FILE * ), write_pix( FILE * ), dfs_visit( int, int );

/* invoke as
			pix_conn infile outfile
 */
main()
{
   FILE *infile, *outfile;
   int i, j;
	char buff[ 80 ];
#if vax11c
	int start_time, end_time;
#endif

	printf( "Infile: " );
	gets( buff );
	if ( ( infile = fopen( buff, "r" ) ) == NULL ) {
		printf( "Unable to open file %s\n", buff );
		exit( EXIT_FAILURE );
   }

	printf( "Outfile: " );
	gets( buff );
	if ( ( outfile = fopen( buff, "w" ) ) == NULL ) {
		printf( "Unable to open file %s\n", buff );
		exit( EXIT_FAILURE );
   }

	read_pix( infile );
	fclose( infile );

#if vax11c
	start_time = elap_time();
#endif
	for ( i = 1; i <= height; i++ )
		for ( j = 1; j <= width; j++ )
			if ( pix[ i ][ j ] == 1 ) {
				dfs_visit( i, j );
				cc++;
			}
#if vax11c
	end_time = elap_time();
	printf( "Time = %d\n", end_time - start_time );
#endif

	write_pix( outfile );
}

void read_pix( FILE *fp )
{
   int i, j;
	char c;

	fscanf( fp, "%d%d", &height, &width );

	for ( i = 1; i <= height; i++ )
		for ( j = 1; j <= width; j++ )
			if ( fscanf( fp, " %c", &c ) != 1 ) {
				printf( "Unable to read file\n" );
				exit( EXIT_FAILURE );
			}
			else
				pix[ i ][ j ] = c - '0';
}

void write_pix( FILE *fp )
{
	int i, j;

	for ( i = 1; i <= height; i++ ) {
		for ( j = 1; j <= width; j++ )
			fprintf( fp, "%4x", pix[ i ][ j ] );
		fputc( '\n', fp );
	}
}

void dfs_visit( int i, int j )
{
	pix[ i ][ j ] = cc;

	if ( pix[ i - 1 ][ j ] == 1 )
		dfs_visit( i - 1, j );
	if ( pix[ i + 1 ][ j ] == 1 )
		dfs_visit( i + 1, j );
	if ( pix[ i ][ j - 1 ] == 1 )
		dfs_visit( i, j - 1 );
	if ( pix[ i ][ j + 1 ] == 1 )
		dfs_visit( i, j + 1 );
}
